<template>
  <li
    class="node__element"
    :class="{ child: parentData }"
    @dragover.prevent
    @dragenter.prevent
    @drop.stop="dragEnd"
  >
    <div
      :class="{
        'btn--small': parentData,
        'btn--main': !parentData
      }"
      :draggable="parentData"
      :style="{
        'background-color': buttonBackgroundColor
      }"
      @dragstart.stop="dragStart"
    >
      <div>
        <p class="node__title">{{ data.title }}</p>
        
        <p
          v-if="parentData"
          class="head-7"
        >Level of nested node - {{ lvlOfNested }}</p>
      </div>
      
      <div class="node__options-btn">
        <div @click.stop="addNestedNode"
        >
          <img src="../../assets/images/plus-circle-outline.svg" alt="add node">
        </div>
        
        <div
          v-if="parentData"
          @click.stop="removeNode"
        >
          <img src="../../assets/images/delete-forever.svg" alt="delete node">
        </div>
      </div>
    </div>
    
    <ul
      v-if="data.children && data.children.length > 0"
      class="node__child"
    >
      <NodeElement
        v-for="(nodeData, di) in data.children"
        :data="nodeData"
        :parentData="data"
        :lvlOfNested="lvlOfNested + 1"
        :key="`${di} ${nodeData.title}`"
      />
    </ul>
  </li>
</template>

<script>
  import {
    ADD_NESTED_NODE,
    REMOVE_NESTED_NODE
  } from '../../store/node/mutations'

  import dragObj from './dragObj'

  export default {
    name: 'NodeElement',
    props: {
      data: {
        type: Object,
        default: () => {}
      },
      parentData: {
        type: Object,
        default: null
      },
      lvlOfNested: {
        type: Number
      },
      isParent: {
        type: Boolean,
        default: false
      }
    },

    computed: {
      buttonBackgroundColor() {
        const listOfColors = [
          '#f44336',
          '#e91e63',
          '#9c27b0',
          '#673ab7',
          '#2196f3',
          '#03a9f4',
          '#00bcd4',
          '#009688',
          '#4caf50',
          '#8bc34a',
          '#8bc34a',
          '#ff9800',
          '#ff5722',
          '#795548',
          '#9e9e9e',
          '#607d8b'
        ]

        const index = Math.floor(Math.random() * (listOfColors.length - 1 - 0 + 1)) + 0
        return listOfColors[index]
      }
    },

    methods: {
      removeNode() {
        this.$store.commit(REMOVE_NESTED_NODE, {
          parentObject: this.parentData,
          objectForRemove: this.data
        })
      },

      addNestedNode() {
        const nestedNodeTitle = prompt('Write element title', '');

        if(!nestedNodeTitle) return

        const objectToMove = {
          title: nestedNodeTitle
        }

        this.$store.commit(ADD_NESTED_NODE, {
            objectToUpdate: this.data,
            objectToMove
          }
        )
      },

      dragStart() {
        dragObj.objectToMove = this.data
        dragObj.objectFromWhichToRemove = this.parentData
      },

      dragEnd() {
        if(dragObj.objectToMove && dragObj.objectFromWhichToRemove && dragObj.objectToMove !== this.data) {
          this.$store.commit(REMOVE_NESTED_NODE, {
            parentObject: dragObj.objectFromWhichToRemove,
            objectForRemove: dragObj.objectToMove
          })

          this.$store.commit(ADD_NESTED_NODE, {
            objectToUpdate: this.data,
            objectToMove: dragObj.objectToMove
          })
        }

        delete dragObj.objectToMove
        delete dragObj.objectFromWhichToRemove
      }
    }
  }
</script>

<style lang="scss">
  .node__child {
    margin-left: 1rem;
    padding: 0;
    position: relative;
  
    &:after {
      position: absolute;
      top: calc(50% - 1px);
      right: 100%;
      content: '';
      display: inline-block;
      width: 1rem;
      height: 2px;
      background-color: var(--color-light-grey);
    }
  }

  .node__element {
    display: flex;
    align-items: center;
    list-style: none;

    li {
      margin: 1rem;

      &:first-child {
        margin-top: 0;
      }

      &:last-child {
        margin-bottom: 0;
      }
    }

    .btn--main {
      min-width: 220px;
      padding: 1rem;
      display: flex;
      align-items: center;
      justify-content: space-between;
      flex-shrink: 0;
      color: var(--button-text-color-1);
      border-radius: 35px;
      font-weight: 600;
      text-transform: uppercase;

      .node__title {
        max-width: 200px;
        margin: 0;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
      }
    }

    .btn--small {
      min-width: 220px;
      padding: .5rem .5rem .5rem 1rem;
      display: flex;
      align-items: center;
      justify-content: space-between;
      flex-shrink: 0;
      color: var(--button-text-color-1);
      border-radius: 35px;
      font-weight: 600;
      text-transform: capitalize;
      transition: opacity .3s;
      cursor: grab;

      &:hover {
        opacity: .8;
      }

      .node__title {
        max-width: 200px;
        margin: 0;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
      }

      .head-7 {
        margin: .5rem 0 0;
      }
    }

    .node__options-btn {
      margin-left: 1rem;
      display: flex;
      align-items: center;

      img {
        width: 24px;
        height: 24px;
        cursor: pointer;
      }
    }
  }

  .node__element.child {
    position: relative;

    &:after {
      position: absolute;
      top: calc(50% - 1px);
      right: 100%;
      content: '';
      width: 1rem;
      height: 2px;
      background-color: var(--color-light-grey);
    }

    &:before {
      position: absolute;
      left: -1rem;
      content: '';
      width: 2px;
      height: calc(100% + 1rem);
      background-color: var(--color-light-grey);
    }

    &:first-child:before {
      top: 50%;
      height: calc(50% + 1rem);
    }

    &:last-child:before {
      bottom: 50%;
      height: calc(50% + 1rem);
    }

    &:only-child:before {
      height: 0;
    }
  }
</style>
